<?php

class OenologueIterator implements Iterator, Countable {
    protected $id_oenologue = 1;
    private MyPDO $myPDOOenologue;

    public function __construct()
    {
        $this->myPDOOenologue = new MyPDO($_ENV['host'], $_ENV['db'], $_ENV['user'], $_ENV['password'], 'oenologue');
    }

    public function count(){
        return $this->myPDOOenologue->count();
    }

    public function current(){
        return $this->myPDOOenologue->get("id_oenologue",$this->id_oenologue);
    }

    public function key(){
        return $this->id_oenologue;
    }

    public function next(){
        $val = $this->myPDOOenologue->get("id_oenologue",0);
        $this->id_oenologue++;
        if( $this->id_oenologue < $this->myPDOOenologue->getMax("id_oenologue") && $this->myPDOOenologue->get("id_oenologue",$this->id_oenologue) == $val )
            $this->next();
    }

    public function rewind(){
        $this->id_oenologue = 1;
    }

    public function valid(){
        return $this->id_oenologue > 0 && $this->id_oenologue <= $this->myPDOOenologue->getMax("id_oenologue");
    }
}
?>
